library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity povp_tb is
end povp_tb;

architecture sim of povp_tb is
 signal ap_clk, ap_rst : std_logic := '1';
 signal ap_start : std_logic := '0';
 signal ap_done, ap_idle, ap_ready : std_logic;
 signal data_V_address0 : STD_LOGIC_VECTOR (2 downto 0);
 signal data_V_ce0 : STD_LOGIC;
 signal data_V_q0 : STD_LOGIC_VECTOR (9 downto 0);
 signal out_V : std_logic_vector(9 downto 0);
 constant T : time := 10 ns;
 
 type ram_t is array ( 0 to 7) of integer;
 signal ram: ram_t := (100,200,300,400,500,600,700,800);
 
begin

uut: entity work.povp port map(
	 ap_clk => ap_clk,
	 ap_rst => ap_rst,
	 ap_start => ap_start,
	 ap_done => ap_done,
	 ap_idle => ap_idle,
	 ap_ready => ap_ready,
	 data_V_address0 => data_V_address0,
	 data_V_ce0 => data_V_ce0,
	 data_V_q0 => data_V_q0,
	 out_V => out_V
);

-- Memory interface
data_V_q0 <= std_logic_vector(to_unsigned(ram(to_integer(unsigned(data_V_address0))), 10));

-- Clock generator
clk_gen: process
begin
 ap_clk <= '1';  wait for T/2;
 ap_clk <= '0';  wait for T/2;
end process;

ap_rst <= '1', '0' after T;
ap_start <= '0', '1' after T, '0' after 2*T;

end sim;